<!DOCTYPE html>
<html>

<head>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
  <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <title>Bizzare Pizza</title>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.7.3/Chart.js"></script>
  <link rel="apple-touch-icon" sizes="180x180" href="/apple-touch-icon.png">
  <link rel="icon" type="image/png" sizes="256x256" href="/favicon.ico" />
  <link rel="manifest" href="/site.webmanifest">
  <link rel="mask-icon" href="/safari-pinned-tab.svg" color="#5bbad5">
  <meta name="msapplication-TileColor" content="#da532c">
  <meta name="theme-color" content="#ffffff">
</head>

<body>
  <div class="container-fluid">
    <div class="row">
      <div class="col-sm pr-0 pl-0">
        <nav class="navbar navbar-expand-lg navbar-dark bg-dark justify-content-between">
          <a class="navbar-brand" href="#">Статистика</a>
          <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
            <div class="navbar-nav">
              <a class="nav-item nav-link active" href="">Состояние склада<span class="sr-only">(current)</span></a>
              <a class="nav-item nav-link" href="dish.html">Статистика блюд</a>
              <a class="nav-item nav-link" href="orders.html">История заказов</a>
              <a class="nav-item nav-link" href="income.html">Статистика прибыли</a>
            </div>
          </div>
          <select style="margin-right:10px" id="categ">
            <option value="Всё">Всё</option>
          </select>
          <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavAltMarkup"
            aria-controls="navbarNavAltMarkup" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
        </nav>
      </div>
    </div>
    <div class="row">
      <canvas id="myChart"></canvas>
    </div>
    <div class="row" id="table">

    </div>
    <script>

      fetch('http://app.bizzarepizza.xyz/stats/warehouse/amounts')
        .then(function (response) {
          return response.json()
        })
        .then(function (data) {

          // VARIABLES AND ELEMNT GETTING
          var all_info = data.data
          var barLabels = []; var categories = []; foodInfo = []; current_category = "Всё";
          var select_categories = document.getElementById("categ")


          // SET INFORMATION IN VARS
          for (var i = 0; i < all_info.length; i++) {
            barLabels.push(all_info[i].name)
            if (categories.includes(all_info[i].category) == false) {
              categories.push(all_info[i].category)
            }
            foodInfo.push({ name: all_info[i].name, amount: all_info[i].amount, category: all_info[i].category })
          }

          var hackedBarLabels = Array.from(barLabels)

          for (var i = 0; i < categories.length; i++) {
            opt = document.createElement("option");
            opt.value = categories[i];
            opt.textContent = categories[i];
            select_categories.appendChild(opt);
          }

          document.getElementById("categ").onchange = function () {
            current_category = this.value
            on_category_ch();
          };


          // CHART.JS CONFIG
          var config = {
            type: 'horizontalBar',
            data: {
              labels: hackedBarLabels,
              datasets: []
            },
            options: {
            }
          }

          //DATASETS DECLARATION
          var dataset = []
          var nowOnline = { label: "Сейчас на складе", data: [] } // Products that are available now
          for (var i = 0; i < foodInfo.length; i++) {
            nowOnline["data"].push(foodInfo[i].amount)
          }

          dataset.push(nowOnline)
          config.data.datasets = dataset.slice(0)

          var ctx = document.getElementById("myChart");
          var myChart = new Chart(ctx, config);

          function on_category_ch() {
            dataset = []
            var nowOnline = { label: "Сейчас на складе", data: [] } // Products that are available now
            for (var i = 0; i < foodInfo.length; i++) {
              nowOnline["data"].push(foodInfo[i].amount)
            }

            dataset.push(nowOnline)

            config.data.labels = barLabels.slice(0)
            config.data.datasets[0].data = dataset[0].data.slice(0)

            if (current_category != "Всё") {
              for (var i = 0; i < foodInfo.length; i++) {
                1
                if (foodInfo[i].category != current_category) {
                  config.data.labels[i] = undefined
                  config.data.datasets[0].data[i] = undefined
                }
              }
            }

            config.data.labels = config.data.labels.filter(function (el) { return el != undefined; })
            config.data.datasets[0].data = config.data.datasets[0].data.filter(function (el) { return el != undefined; })

            console.log(dataset[0].data)
            console.log(config.data.datasets[0].data)

            if (config.data.labels.length == 0) {
              myChart.getDatasetMeta(0).hidden = true;
            } else {
              myChart.getDatasetMeta(0).hidden = false;
            }
            hackedBarLabels = config.data.labels
            myChart.update();
          }
        });
    </script>
  </div>
  </div>
</body>

</html>
